{
    FreeWinRally - Un programma per ricevere via packet i tempi dei rally
    Copyright (C) 2000, 2001, 2002 Sezione ARI Casale Monferrato & I1EPJ

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

unit Config;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, TabNotBk, StdCtrls, Buttons, ExtCtrls, Grids, Spin, Menus,
  UClass;

const
	PrgName = 'WinRally';
	PrgVers = '0.8';
   PrgBuild= '20031206';
   DCBError= 'Non riesco a costruire il DCB!';
   COMError= 'Non posso aprire %s (Errore #%d)';
   HelpMsg = 'Da scrivere...';

type
  TConfForm = class(TForm)
    ConfDlg: TTabbedNotebook;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
	 NomeRally: TEdit;
    Label1: TLabel;
    RGTnc: TRadioGroup;
	 RGVelo: TRadioGroup;
    RGPari: TRadioGroup;
    RGBits: TRadioGroup;
    RGStops: TRadioGroup;
    RGHand: TRadioGroup;
	 Label27: TLabel;
    ListaOM: TStringGrid;
    RGTempi: TRadioGroup;
    RGStampa: TRadioGroup;
    RGTNCInit: TRadioGroup;
    KmPS: TStringGrid;
    Label2: TLabel;
    TxDati: TEdit;
    Label3: TLabel;
    Descr: TMemo;
	 Label5: TLabel;
    Label6: TLabel;
	 RgAvviso: TRadioGroup;
    Info: TMemo;
    GroupBox1: TGroupBox;
	 NumCopie: TSpinEdit;
    Label4: TLabel;
    MyCallBox: TGroupBox;
    MyCall: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    FontDialog1: TFontDialog;
    Ldescr: TLabel;
    Button1: TButton;
    Button2: TButton;
    LInfo: TLabel;
    LIntest: TLabel;
    LTempi: TLabel;
    LCopy: TLabel;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    LNomeRally: TLabel;
    Label18: TLabel;
    Button6: TButton;
    Button7: TButton;
    LCura: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    LRic: TLabel;
    Button8: TButton;
    GroupBox2: TGroupBox;
    PrintDPI: TSpinEdit;
    SGClassi: TStringGrid;
    Memo1: TMemo;
    NumGiro: TSpinEdit;
    Label14: TLabel;
    GroupBox3: TGroupBox;
    RGPorta: TComboBox;
    Nota: TGroupBox;
    Label16: TLabel;
    Label17: TLabel;
    InvioDati: TCheckBox;
    ConfBox: TGroupBox;
    Tappa: TSpinEdit;
    COMList: TComboBox;
    Label15: TLabel;
    Label19: TLabel;
    AutoCrono: TCheckBox;
    procedure OKBtnClick(Sender: TObject);
	 procedure CancelBtnClick(Sender: TObject);
    procedure ConfDlgEnter(Sender: TObject);
    procedure RGPariClick(Sender: TObject);
    procedure RGVeloClick(Sender: TObject);
    procedure RGBitsClick(Sender: TObject);
    procedure RGStopsClick(Sender: TObject);
    procedure RGHandClick(Sender: TObject);
    procedure RGTncClick(Sender: TObject);
    procedure ListaOMSetEditText(Sender: TObject; ACol, ARow: Longint;
      const Value: String);
	 procedure RGTempiClick(Sender: TObject);
    procedure RGStampaClick(Sender: TObject);
    procedure RGTNCInitClick(Sender: TObject);
    procedure KmPSSetEditText(Sender: TObject; ACol, ARow: Longint;
	   const Value: String);
    procedure RgAvvisoClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure MycallChange(Sender: TObject);
    procedure NumCopieChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure InitTNC(TNCInitI,TNCType: Integer);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure PrintDPIChange(Sender: TObject);
    procedure NumGiroChange(Sender: TObject);
    procedure InvioDatiClick(Sender: TObject);
    procedure RGPortaChange(Sender: TObject);
    procedure COMListChange(Sender: TObject);
    procedure TappaChange(Sender: TObject);
    procedure AutoCronoClick(Sender: TObject);

  private
	 { Private declarations }
  public
    { Public declarations }
  end;

  TRallyData = record
     MyCall: string[20];
	  NomeRally: string[100];
	  DescrRally: array[1..2] of string[100];
	  InfoRally: array[1..2] of string[100];
	  TxDatiBy: string[100];
	  CallPS: array[1..50] of String[20];
	  KmPS: array[1..50] of single;
  end;

  TTempo = record
	  Minuti: integer;
	  Secondi: integer;
	  Centesimi: integer;
  end;

  TConcorrente = record
	  Numero: integer;
	  Tempo: TTempo;
	  Note: string[40];
  end;

  TTempi = array [1..5] of TConcorrente;

  TFoglio = record
		 PSCall: string[20];
		 PSNum: integer;
		 FoglioNum: integer;
		 NumTempi: integer;
		 Tempi: TTempi;
		 Note: array[1..2] of string[80];
		 OraRicezione: TDateTime;
		 Stampato: boolean;
  end;

  TFontData = record
  		Name: string[32];
       Size: integer;
       Color: TColor;
       Style: TFontStyles;
  end;

  TSheetFonts = record
  		Font1: TFontData;
  		Font2: TFontData;
  		Font3: TFontData;
  		Font4: TFontData;
       Font5: TFontData;
       Font6: TFontData;
       Font7: TFontData;
       Font8: TFontData;
   end;

  TConf = record
		PortNameI,CronoPortNameI,PortSpeedI,PortParityI,PortBitsI,PortStopsI,
       PortHandI,TNCTypeI,TimeFormatI,AutoPrintI,TNCInitI,
		NewSheetI,NumCopiesI,PrintDPII: Integer;
       SendCrono: Boolean;
		RallyData: TRallyData;
       SheetFonts: TsheetFonts;
       Classifica: array[0..MAXCONC] of TClassifica;
  end;

  TOMConn = record
		PS: integer;
		Stream: char;
		Call: string[20];
  end;

Const TASCO = 0;
	   TNC2_10 = 1;
	   TNC2_5 = 2;
	   PK232 = 3;

var
	ComModified, CronoModified: Boolean;
	ConfForm: TConfForm;
	Conf: TConf;
	RallyFile: File;
	ConfFile: File of TConf;
	Quaderno: file of TFoglio;
	RawLogFile: TextFile;
   NomeFile: string;

	PortNum, CronoPortNum, Ncopie, NGiro: Integer;
	PortName,CronoPortName,PortSpeed,PortParity,PortBits,PortStops: PChar;
	PortHand, TNCType: Integer;
	PortNameI,PortSpeedI,PortParityI,PortBitsI,PortStopsI: Integer;
	PortHandI,CronoPortNameI, TNCTypeI,TimeFormatI,AutoPrintI,TNCInitI, NewSheetI,
	PrintDPII,NumTappa: Integer;
   SendCrono: Boolean;
	RallyData: TRallyData;
	Foglio, Foglio1, FoglioPrev: TFoglio;
	OmConn: array[1..50] of TOMConn;
	TNCInitCmds: array[TASCO..PK232,1..20] of string[40];
	FontT1, FontT2, FontT3, FontT4, FontT5, FontT6, FontT7, FontT8: TFontData;

implementation

{$R *.DFM}

uses Rally;


procedure TConfForm.OKBtnClick(Sender: TObject);

var dcb: TDCB;
	 s: string;
	 buf: array[0..80] of char;
	 Ret,i,n,m: integer;
	 LSpeed: longint;
    Presente: boolean;
    MClassi: TMenuItem;

begin
	  RallyData.NomeRally := NomeRally.Text;
	  RallyData.MyCall := MyCall.Text;
	  RallyData.DescrRally[1] := Descr.Lines[0];
	  RallyData.DescrRally[2] := Descr.Lines[1];
	  RallyData.Inforally[1] := Info.Lines[0];
	  RallyData.Inforally[2] := Info.Lines[1];
	  RallyData.TxDatiBy := TxDati.Text;
	  TNCType := TNCTypeI;
     for n := 1 to MAXCONC-1 do begin
 	  	Classifica[n].Classe := SGClassi.Cells[1,n];
     end;
     Move(Classifica, Conf.Classifica, SizeOf(Conf.Classifica));

     if PortName = nil then PortName := StrAlloc(5);
	  StrFmt(PortName, 'COM%d', [PortNameI]);
     if CronoPortName = nil then CronoPortName := StrAlloc(5);
	  StrFmt(CronoPortName, 'COM%d', [CronoPortNameI]);

	  case PortParityI of
		   0: PortParity := ',N';
		   1: PortParity := ',O';
		   2: Portparity := ',E';
	  end;
	  case PortSpeedI of
		   0: PortSpeed := ',1200';
		   1: PortSpeed := ',2400';
		   2: PortSpeed := ',4800';
		   3: PortSpeed := ',9600';
		   4: PortSpeed := ',19200';
		   5: PortSpeed := ',38400';
		   6: PortSpeed := ',57600';
		   7: PortSpeed := ',115200';
		   else PortSpeed := ',9600';
	  end;
	  case PortBitsI of
		   0: PortBits := ',7';
		   1: PortBits := ',8';
	  end;
	  case PortStopsI of
		   0: PortStops := ',1';
		   1: PortStops := ',2';
	  end;

    Conf.PortNameI   := PortnameI;
	 Conf.CronoPortNameI := CronoPortNameI;
    Conf.SendCrono  := SendCrono;
	 Conf.PortSpeedI  := PortSpeedI;
	 Conf.PortParityI := PortParityI;
	 Conf.PortBitsI   := PortBitsI;
	 Conf.PortStopsI  := PortStopsI;
	 Conf.PortHandI   := PortHandI;
	 Conf.TNCTypeI    := TncTypeI;
	 Conf.TimeFormatI := TimeFormatI;
	 Conf.AutoPrintI  := AutoPrintI;
	 Conf.TNCInitI    := TNCInitI;
	 Conf.NewSheetI   := NewSheetI;
    Conf.NumCopiesI  := NCopie;
    Conf.PrintDPII   := PrintDPII;
	 Conf.RallyData   := RallyData;

    with Conf.SheetFonts do begin
		Font1.Name := FontT1.Name;
		Font1.Size := FontT1.Size;
		Font1.Style := FontT1.Style;
		Font1.Color := FontT1.Color;
		Font2.Name := FontT2.Name;
		Font2.Size := FontT2.Size;
		Font2.Style := FontT2.Style;
		Font2.Color := FontT2.Color;
		Font3.Name := FontT3.Name;
		Font3.Size := FontT3.Size;
		Font3.Style := FontT3.Style;
		Font3.Color := FontT3.Color;
		Font4.Name := FontT4.Name;
		Font4.Size := FontT4.Size;
		Font4.Style := FontT4.Style;
		Font4.Color := FontT4.Color;
		Font5.Name := FontT5.Name;
		Font5.Size := FontT5.Size;
		Font5.Style := FontT5.Style;
		Font5.Color := FontT5.Color;
		Font6.Name := FontT6.Name;
		Font6.Size := FontT6.Size;
		Font6.Style := FontT6.Style;
		Font6.Color := FontT6.Color;
		Font7.Name := FontT7.Name;
		Font7.Size := FontT7.Size;
		Font7.Style := FontT7.Style;
		Font7.Color := FontT7.Color;
		Font8.Name := FontT8.Name;
		Font8.Size := FontT8.Size;
		Font8.Style := FontT8.Style;
		Font8.Color := FontT8.Color;
	end;

	AssignFile(ConfFile, 'WINRALLY.CNF');
	Rewrite(ConfFile);
	Write(ConfFile, Conf);
	CloseFile(ConfFile);

	FRally.Caption := 'FreeWinRally - ' + Conf.RallyData.NomeRally;

	FRally.CostruisciMenuConnetti;
	Frally.CostruisciMenuClasse;

	if CronoModified then begin
		CloseComm(CronoPortNum);
       if InvioDati.Checked then begin
			repeat
				CronoPortNum := OpenComm(CronoPortName, RxBufSize, TxBufSize);
				if CronoPortNum >= 0 then begin
					StrCopy(buf,CronoPortName);
					StrCat(buf,',2400');
					StrCat(buf,',N');
					StrCat(buf,',8');
					StrCat(buf,',2');
				  	if BuildCommDCB(buf, dcb) < 0 then begin
              			StrCopy(buf, DCBerror);
			   			Ret := Application.MessageBox(buf,'Errore!' , MB_ABORTRETRYIGNORE+MB_ICONSTOP+MB_DEFBUTTON1);
			   			if Ret = IDABORT then Halt;
           		end;
				  	dcb.Flags := dcb_Binary or dcb_OutX or dcb_InX;
				  	SetCommState(dcb);
			   end else begin
				   StrFmt(buf, COMError,[CronoPortName,-CronoPortNum]);
				   Ret := Application.MessageBox(buf,'Errore!' , MB_ABORTRETRYIGNORE+MB_ICONSTOP+MB_DEFBUTTON1);
				   if Ret = IDABORT then Halt;
			   end;
	  		until (PortNum >= 0) OR (Ret = IDIGNORE);
       end;
	end;

	if ComModified then begin
		CloseComm(PortNum);
		repeat
			PortNum := OpenComm(PortName, RxBufSize, TxBufSize);
			if PortNum >= 0 then begin
				StrCopy(buf,PortName);
				StrCat(buf,PortSpeed);
				StrCat(buf,PortParity);
				StrCat(buf,PortBits);
				StrCat(buf,PortStops);
   			if BuildCommDCB(buf, dcb) < 0 then begin
					StrCopy(buf, DCBerror);
			   		Ret := Application.MessageBox(buf,'Errore!' , MB_ABORTRETRYIGNORE+MB_ICONSTOP+MB_DEFBUTTON1);
			   		if Ret = IDABORT then Halt;
             	end;
			  	dcb.Flags := dcb_Binary;
			  	if PortHand = 0 then begin
               	dcb.Flags := dcb.Flags or dcb_OutxCtsFlow or dcb_Rtsflow;
			  	end else begin
				  	dcb.Flags := dcb.Flags or dcb_OutX or dcb_InX;
			  	end;
			  	SetCommState(dcb);
			  	EnableCommNotification(PortNum,FRally.Handle,512,-1);
			 	{
			  	 Siamo riusciti, nessuno sa come, ad aprire la porta seriale.
			  	 Mandiamo una raffica di comandi di inizializzazione al TNC.
			 	}
			  InitTNC(Conf.TNCInitI, TNCType);
			end else begin
          		StrFmt(buf, COMError,[PortName,-PortNum]);
				Ret := Application.MessageBox(buf,'Errore!' , MB_ABORTRETRYIGNORE+MB_ICONSTOP+MB_DEFBUTTON1);
           	if Ret = IDABORT then Halt;
			end;
	  until (PortNum >= 0) OR (Ret = IDIGNORE);
	end;
	if (TNCType = TNC2_5) or (TNCType = TNC2_10) or (TNCType = TASCO) then
		 LastStream := 'A'
	else
		 LastStream := '0';
	ConfForm.Visible := False;
end;

procedure TConfForm.CancelBtnClick(Sender: TObject);
begin
		FontT1.Name := Conf.SheetFonts.Font1.Name;
		FontT1.Size := Conf.SheetFonts.Font1.Size;
		FontT1.Style := Conf.SheetFonts.Font1.Style;
		FontT1.Color := Conf.SheetFonts.Font1.Color;
		FontT2.Name := Conf.SheetFonts.Font2.Name;
		FontT2.Size := Conf.SheetFonts.Font2.Size;
		FontT2.Style := Conf.SheetFonts.Font2.Style;
		FontT2.Color := Conf.SheetFonts.Font2.Color;
		FontT3.Name := Conf.SheetFonts.Font3.Name;
		FontT3.Size := Conf.SheetFonts.Font3.Size;
		FontT3.Style := Conf.SheetFonts.Font3.Style;
		FontT3.Color := Conf.SheetFonts.Font3.Color;
		FontT4.Name := Conf.SheetFonts.Font4.Name;
		FontT4.Size := Conf.SheetFonts.Font4.Size;
		FontT4.Style := Conf.SheetFonts.Font4.Style;
		FontT4.Color := Conf.SheetFonts.Font4.Color;
		FontT5.Name := Conf.SheetFonts.Font5.Name;
		FontT5.Size := Conf.SheetFonts.Font5.Size;
		FontT5.Style := Conf.SheetFonts.Font5.Style;
		FontT5.Color := Conf.SheetFonts.Font5.Color;
		FontT6.Name := Conf.SheetFonts.Font6.Name;
		FontT6.Size := Conf.SheetFonts.Font6.Size;
		FontT6.Style := Conf.SheetFonts.Font6.Style;
		FontT6.Color := Conf.SheetFonts.Font6.Color;
		FontT7.Name := Conf.SheetFonts.Font7.Name;
		FontT7.Size := Conf.SheetFonts.Font7.Size;
		FontT7.Style := Conf.SheetFonts.Font7.Style;
		FontT7.Color := Conf.SheetFonts.Font7.Color;
		FontT8.Name := Conf.SheetFonts.Font8.Name;
		FontT8.Size := Conf.SheetFonts.Font8.Size;
		FontT8.Style := Conf.SheetFonts.Font8.Style;
		FontT8.Color := Conf.SheetFonts.Font8.Color;
	    ConfForm.Visible := False;
end;

procedure TConfForm.ConfDlgEnter(Sender: TObject);

var n: integer;
	 s: string[10];

begin

   COMList.Items.Clear;
	for n := 1 to 9 do begin
   	if COMAvailable[n] <> '' then begin
       	COMList.Items.Add(COMAvailable[n]);
           RGPorta.Items.Add(COMAvailable[n]);
       end;
   end;
   COMList.ItemIndex := 0;
   RGPorta.ItemIndex := 0;

	NomeRally.Text := Conf.RallyData.NomeRally;

	RGTnc.ItemIndex := Conf.TNCTypeI;
	RGTNCInit.ItemIndex := Conf.TNCInitI;
	MyCall.Text := Conf.RallyData.MyCall;
	if Conf.TNCInitI = 0 then begin
		MyCallBox.Enabled := True;
	end else begin
		MyCallBox.Enabled := False;
	end;

	if Conf.PortNameI > 0 then
   	RGPorta.Text := 'COM'+chr(ord('0')+Conf.PortNameI)
   else
   	RGPorta.Text := '';

   if Conf.CronoPortNameI > 0 then begin
   	COMLIst.Text := 'COM'+chr(ord('0')+Conf.CronoPortNameI);
       InvioDati.Checked := TRUE;
		if Conf.SendCrono then begin
       	AutoCrono.Checked := TRUE;
   	end;
   end else begin
   	COMList.Text := '';
   	InvioDati.Checked := FALSE
	end;

	RGVelo.ItemIndex := Conf.PortSpeedI;
	RGPari.ItemIndex := Conf.PortParityI;
	RGBits.ItemIndex := Conf.PortBitsI;
	RGStops.ItemIndex := Conf.PortStopsI;
	RGHand.ItemIndex := Conf.PortHandI;
	RGTempi.ItemIndex := Conf.TimeFormatI;
	RGStampa.ItemIndex := Conf.AutoPrintI;
	RGAvviso.ItemIndex := Conf.NewSheetI;

	  Descr.Clear;
	  Descr.Lines.Add(Conf.RallyData.DescrRally[1]);
	  Descr.Lines.Add(Conf.RallyData.DescrRally[2]);
	  Info.Clear;
	  Info.Lines.Add(Conf.RallyData.InfoRally[1]);
	  Info.Lines.Add(Conf.RallyData.InfoRally[2]);
	  TxDati.Text := Conf.RallyData.TxDatiBy;

	  ListaOM.Cells[0,0] := 'P.S.';
	  ListaOM.Cells[1,0] := 'Nominativo';
	  KmPS.Cells[0,0] := 'P.S.';
	  KmPS.Cells[1,0] := 'Lunghezza Km';
	  for n := 1 to 50 do begin
		  Str(n:5,s);
		  ListaOM.Cells[0,n] := s;
		  KmPS.Cells[0,n] := s;
		  ListaOm.Cells[1,n] := Conf.RallyData.CallPS[n];
		  Str(Conf.RallyData.KmPs[n]:2:2, s);
		  KmPs.Cells[1,n] := s;
	  end;
	  NumCopie.Value := NCopie;
     PrintDPI.Value := PrintDPII;
	  ComModified := FALSE;
     CronoModified := FALSE;

	  LNomeRally.Font.Name := FontT1.Name;
	  LNomeRally.Font.Size := FontT1.Size;
	  LNomeRally.Font.Style := FontT1.Style;
	  LNomeRally.Font.Color := FontT1.Color;
     LNomerally.Caption := FontT1.Name;

	  LDescr.Font.Name := FontT2.Name;
	  LDescr.Font.Size := FontT2.Size;
	  LDescr.Font.Style := FontT2.Style;
	  LDescr.Font.Color := FontT2.Color;
     LDescr.Caption := FontT2.Name;

	  LInfo.Font.Name := FontT3.Name;
	  LInfo.Font.Size := FontT3.Size;
	  LInfo.Font.Style := FontT3.Style;
	  LInfo.Font.Color := FontT3.Color;
     LInfo.Caption := FontT3.Name;

	  LIntest.Font.Name := FontT4.Name;
	  LIntest.Font.Size := FontT4.Size;
	  LIntest.Font.Style := FontT4.Style;
	  LIntest.Font.Color := FontT4.Color;
     LIntest.Caption := FontT4.Name;

	  LTempi.Font.Name := FontT5.Name;
	  LTempi.Font.Size := FontT5.Size;
	  LTempi.Font.Style := FontT5.Style;
	  LTempi.Font.Color := FontT5.Color;
     LTempi.Caption := FontT5.Name;

	  LRic.Font.Name := FontT6.Name;
	  LRic.Font.Size := FontT6.Size;
	  LRic.Font.Style := FontT6.Style;
	  LRic.Font.Color := FontT6.Color;
     LRic.Caption := FontT6.Name;

  	  LCura.Font.Name := FontT7.Name;
	  LCura.Font.Size := FontT7.Size;
	  LCura.Font.Style := FontT7.Style;
	  LCura.Font.Color := FontT7.Color;
     LCura.Caption := FontT7.Name;

	  LCopy.Font.Name := FontT8.Name;
	  LCopy.Font.Size := FontT8.Size;
	  LCopy.Font.Style := FontT8.Style;
	  LCopy.Font.Color := FontT8.Color;
     LCopy.Caption := FontT8.Name;

     SGClassi.Cells[0,0] := 'N';
     SGClassi.Cells[1,0] := 'Classe';
     for n := 1 to MAXCONC do begin
     	Str(n:3, s);
     	SGClassi.Cells[0,n] := s;
		SGClassi.Cells[1,n] := Classifica[n].Classe;
     end;
     NumGiro.Value := NGiro;
end;

procedure TConfForm.RGPariClick(Sender: TObject);

begin
	  PortParityI := RGPari.ItemIndex;
	  ComModified := TRUE;
end;

procedure TConfForm.RGVeloClick(Sender: TObject);
begin
	PortSpeedI := RGVelo.ItemIndex;
	ComModified := TRUE;
end;

procedure TConfForm.RGBitsClick(Sender: TObject);
begin
	PortBitsI := RGBits.ItemIndex;
	ComModified := TRUE;
end;

procedure TConfForm.RGStopsClick(Sender: TObject);
begin
	  PortStopsI := RGStops.ItemIndex;
	  ComModified := TRUE;
end;

procedure TConfForm.RGHandClick(Sender: TObject);
begin
	  PortHandI := RGHand.ItemIndex;
	  ComModified := TRUE;
end;

procedure TConfForm.RGTncClick(Sender: TObject);

var buf: array[0..80] of char;
	 ret: integer;

begin
	  TNCTypeI := RGTnc.ItemIndex;
	  ComModified := TRUE;
end;

procedure TConfForm.ListaOMSetEditText(Sender: TObject; ACol,
  ARow: Longint; const Value: String);
begin
	  RallyData.CallPS[ARow] := Value;
end;

procedure TConfForm.RGTempiClick(Sender: TObject);
begin
	TimeFormatI := RGTempi.ItemIndex;
end;

procedure TConfForm.RGStampaClick(Sender: TObject);
begin
		AutoPrintI := RGStampa.ItemIndex;
end;

procedure TConfForm.RGTNCInitClick(Sender: TObject);
begin
	TNCInitI := RGTNCInit.ItemIndex;
	if TNCInitI = 0 then begin
		MyCallBox.Enabled := True;
	end else begin
		MyCallBox.Enabled := False;
	end;
	  ComModified := TRUE;
end;

procedure TConfForm.KmPSSetEditText(Sender: TObject; ACol, ARow: Longint;
  const Value: String);

  var err: integer;
	   Km: Single;

begin
	  Val(Value, Km, err);
	  RallyData.KmPS[ARow] := Km;
end;

procedure TConfForm.InitTNC(TNCInitI, TNCType: integer);

var n,len: integer;
	 buf: array[0..40] of char;
	 t: TDateTime;

begin
	buf[0] := chr(192);
	buf[1] := chr(255);
	buf[2] := chr(192);
	WriteComm(PortNum, buf, 3);
	t := Time;
	Repeat until (Time-t) > 2/86400;
	buf[0] := CTRLC;
	buf[1] := CTRLC;
	buf[2] := CTRLC;
	WriteComm(PortNum, buf, 3);
	t := Time;
	Repeat until (Time-t) > 2/86400;
	buf[0] := CR;
	WriteComm(PortNum, buf, 1);
	if TNCInitI = 0 then begin
		StrFmt(buf,'MYCALL %s', [Conf.RallyData.MyCall]);
		Len := StrLen(buf);
		buf[Len] := CR;
		buf[Len+1] := NULL;
		WriteComm(PortNum, buf, Len+1);
		Repeat until Time-t > 2/864000;
	end;
	for n := 1 to 20 do begin
		if TNCInitCmds[TNCType,n] = '' then break;
		StrPCopy(buf, TNCInitCmds[TNCType,n]);
		Len := StrLen(buf);
		buf[Len] := CR;
		buf[Len+1] := NULL;
		WriteComm(PortNum, buf, Len+1);
		{ Aspetta 200 ms prima di dare il comando successivo }
		t := Time;
		Repeat until (Time-t) > 2/864000;
	end;
end;

procedure TConfForm.RgAvvisoClick(Sender: TObject);
begin
		NewSheetI := RGAvviso.ItemIndex;
end;

procedure TConfForm.HelpBtnClick(Sender: TObject);

begin
		Application.MessageBox(HelpMsg, 'Cercansi amanuensi...',MB_OK+MB_ICONQUESTION);
end;

procedure TConfForm.MycallChange(Sender: TObject);
begin
		COMModified := TRUE;
end;

procedure TConfForm.NumCopieChange(Sender: TObject);
begin
		Ncopie := NumCopie.Value;
end;

procedure TConfForm.Button1Click(Sender: TObject);

begin
	FontDialog1.Font.Name := FontT1.Name;
	FontDialog1.Font.Size := FontT1.Size;
	FontDialog1.Font.Style := FontT1.Style;
	FontDialog1.Font.Color := FontT1.Color;
	if FontDialog1.Execute then begin
       LNomerally.Caption := FontDialog1.Font.Name;
		LNomerally.Font.Name := FontDialog1.Font.Name;
		LNomerally.Font.Size := FontDialog1.Font.Size;
		LNomerally.Font.Style := FontDialog1.Font.Style;
		LNomerally.Font.Color := FontDialog1.Font.Color;

		FontT1.Name := FontDialog1.Font.Name;
		FontT1.Size := FontDialog1.Font.Size;
		FontT1.Style := FontDialog1.Font.Style;
		FontT1.Color := FontDialog1.Font.Color;
   end else begin
		FontT1.Name := Conf.SheetFonts.Font1.Name;
		FontT1.Size := Conf.SheetFonts.Font1.Size;
		FontT1.Style := Conf.SheetFonts.Font1.Style;
		FontT1.Color := Conf.SheetFonts.Font1.Color;
   end;
end;

procedure TConfForm.Button2Click(Sender: TObject);

begin
	FontDialog1.Font.Name := FontT2.Name;
	FontDialog1.Font.Size := FontT2.Size;
	FontDialog1.Font.Style := FontT2.Style;
	FontDialog1.Font.Color := FontT2.Color;
	if FontDialog1.Execute then begin
       LDescr.Caption := FontDialog1.Font.Name;
		LDescr.Font.Name := FontDialog1.Font.Name;
		LDescr.Font.Size := FontDialog1.Font.Size;
		LDescr.Font.Style := FontDialog1.Font.Style;
		LDescr.Font.Color := FontDialog1.Font.Color;

		FontT2.Name := FontDialog1.Font.Name;
		FontT2.Size := FontDialog1.Font.Size;
		FontT2.Style := FontDialog1.Font.Style;
		FontT2.Color := FontDialog1.Font.Color;
   end else begin
		FontT2.Name := Conf.SheetFonts.Font2.Name;
		FontT2.Size := Conf.SheetFonts.Font2.Size;
		FontT2.Style := Conf.SheetFonts.Font2.Style;
		FontT2.Color := Conf.SheetFonts.Font2.Color;
   end;
end;

procedure TConfForm.Button3Click(Sender: TObject);

begin
	FontDialog1.Font.Name := FontT3.Name;
	FontDialog1.Font.Size := FontT3.Size;
	FontDialog1.Font.Style := FontT3.Style;
	FontDialog1.Font.Color := FontT3.Color;
	if FontDialog1.Execute then begin
       LInfo.Caption := FontDialog1.Font.Name;
		LInfo.Font.Name := FontDialog1.Font.Name;
		LInfo.Font.Size := FontDialog1.Font.Size;
		LInfo.Font.Style := FontDialog1.Font.Style;
		LInfo.Font.Color := FontDialog1.Font.Color;

		FontT3.Name := FontDialog1.Font.Name;
		FontT3.Size := FontDialog1.Font.Size;
		FontT3.Style := FontDialog1.Font.Style;
		FontT3.Color := FontDialog1.Font.Color;
   end else begin
		FontT3.Name := Conf.SheetFonts.Font3.Name;
		FontT3.Size := Conf.SheetFonts.Font3.Size;
		FontT3.Style := Conf.SheetFonts.Font3.Style;
		FontT3.Color := Conf.SheetFonts.Font3.Color;
   end;

end;

procedure TConfForm.Button4Click(Sender: TObject);

begin
	FontDialog1.Font.Name := FontT4.Name;
	FontDialog1.Font.Size := FontT4.Size;
	FontDialog1.Font.Style := FontT4.Style;
	FontDialog1.Font.Color := FontT4.Color;
	if FontDialog1.Execute then begin
       LIntest.Caption := FontDialog1.Font.Name;
		LIntest.Font.Name := FontDialog1.Font.Name;
		LIntest.Font.Size := FontDialog1.Font.Size;
		LIntest.Font.Style := FontDialog1.Font.Style;
		LIntest.Font.Color := FontDialog1.Font.Color;

		FontT4.Name := FontDialog1.Font.Name;
		FontT4.Size := FontDialog1.Font.Size;
		FontT4.Style := FontDialog1.Font.Style;
		FontT4.Color := FontDialog1.Font.Color;
   end else begin
		FontT4.Name := Conf.SheetFonts.Font4.Name;
		FontT4.Size := Conf.SheetFonts.Font4.Size;
		FontT4.Style := Conf.SheetFonts.Font4.Style;
		FontT4.Color := Conf.SheetFonts.Font4.Color;
   end;

end;

procedure TConfForm.Button5Click(Sender: TObject);

begin
	FontDialog1.Font.Name := FontT5.Name;
	FontDialog1.Font.Size := FontT5.Size;
	FontDialog1.Font.Style := FontT5.Style;
	FontDialog1.Font.Color := FontT5.Color;
	if FontDialog1.Execute then begin
       LTempi.Caption := FontDialog1.Font.Name;
		LTempi.Font.Name := FontDialog1.Font.Name;
		LTempi.Font.Size := FontDialog1.Font.Size;
		LTempi.Font.Style := FontDialog1.Font.Style;
		LTempi.Font.Color := FontDialog1.Font.Color;

		FontT5.Name := FontDialog1.Font.Name;
		FontT5.Size := FontDialog1.Font.Size;
		FontT5.Style := FontDialog1.Font.Style;
		FontT5.Color := FontDialog1.Font.Color;
   end else begin
		FontT5.Name := Conf.SheetFonts.Font5.Name;
		FontT5.Size := Conf.SheetFonts.Font5.Size;
		FontT5.Style := Conf.SheetFonts.Font5.Style;
		FontT5.Color := Conf.SheetFonts.Font5.Color;
   end;
end;

procedure TConfForm.Button6Click(Sender: TObject);

begin
	FontDialog1.Font.Name := FontT6.Name;
	FontDialog1.Font.Size := FontT6.Size;
	FontDialog1.Font.Style := FontT6.Style;
	FontDialog1.Font.Color := FontT6.Color;
	if FontDialog1.Execute then begin
       LCura.Caption := FontDialog1.Font.Name;
		LCura.Font.Name := FontDialog1.Font.Name;
		LCura.Font.Size := FontDialog1.Font.Size;
		LCura.Font.Style := FontDialog1.Font.Style;
		LCura.Font.Color := FontDialog1.Font.Color;

		FontT6.Name := FontDialog1.Font.Name;
		FontT6.Size := FontDialog1.Font.Size;
		FontT6.Style := FontDialog1.Font.Style;
		FontT6.Color := FontDialog1.Font.Color;
   end else begin
		FontT6.Name := Conf.SheetFonts.Font6.Name;
		FontT6.Size := Conf.SheetFonts.Font6.Size;
		FontT6.Style := Conf.SheetFonts.Font6.Style;
		FontT6.Color := Conf.SheetFonts.Font6.Color;
   end;
end;

procedure TConfForm.Button7Click(Sender: TObject);

begin
	FontDialog1.Font.Name := FontT7.Name;
	FontDialog1.Font.Size := FontT7.Size;
	FontDialog1.Font.Style := FontT7.Style;
	FontDialog1.Font.Color := FontT7.Color;
	if FontDialog1.Execute then begin
       LCura.Caption := FontDialog1.Font.Name;
		LCura.Font.Name := FontDialog1.Font.Name;
		LCura.Font.Size := FontDialog1.Font.Size;
		LCura.Font.Style := FontDialog1.Font.Style;
		LCura.Font.Color := FontDialog1.Font.Color;

		FontT7.Name := FontDialog1.Font.Name;
		FontT7.Size := FontDialog1.Font.Size;
		FontT7.Style := FontDialog1.Font.Style;
		FontT7.Color := FontDialog1.Font.Color;
   end else begin
		FontT7.Name := Conf.SheetFonts.Font7.Name;
		FontT7.Size := Conf.SheetFonts.Font7.Size;
		FontT7.Style := Conf.SheetFonts.Font7.Style;
		FontT7.Color := Conf.SheetFonts.Font7.Color;
   end;
end;

procedure TConfForm.Button8Click(Sender: TObject);

begin
	FontDialog1.Font.Name := FontT8.Name;
	FontDialog1.Font.Size := FontT8.Size;
	FontDialog1.Font.Style := FontT8.Style;
	FontDialog1.Font.Color := FontT8.Color;
	if FontDialog1.Execute then begin
       LCopy.Caption := FontDialog1.Font.Name;
		LCopy.Font.Name := FontDialog1.Font.Name;
		LCopy.Font.Size := FontDialog1.Font.Size;
		LCopy.Font.Style := FontDialog1.Font.Style;
		LCopy.Font.Color := FontDialog1.Font.Color;

		FontT8.Name := FontDialog1.Font.Name;
		FontT8.Size := FontDialog1.Font.Size;
		FontT8.Style := FontDialog1.Font.Style;
		FontT8.Color := FontDialog1.Font.Color;
   end else begin
		FontT8.Name := Conf.SheetFonts.Font8.Name;
		FontT8.Size := Conf.SheetFonts.Font8.Size;
		FontT8.Style := Conf.SheetFonts.Font8.Style;
		FontT8.Color := Conf.SheetFonts.Font8.Color;
   end;
end;

procedure TConfForm.PrintDPIChange(Sender: TObject);
begin
	PrintDPII := PrintDPI.Value;
end;

procedure TConfForm.NumGiroChange(Sender: TObject);
begin
	NGiro := NumGiro.value;
end;

procedure TConfForm.InvioDatiClick(Sender: TObject);
begin
   if InvioDati.Checked then begin
   	ConfBox.Enabled := TRUE;
       Tappa.Enabled := TRUE;
       COMList.Enabled := TRUE;
       Label15.Enabled:= TRUE;
       Label19.Enabled := TRUE;
       AutoCrono.Enabled := TRUE;
       Tappa.Font.Color := clBlack;
   end else begin
   	ConfBox.Enabled := FALSE;
       Tappa.Enabled := FALSE;
       COMList.Enabled := FALSE;
       Label15.Enabled:= FALSE;
       Label19.Enabled := FALSE;
       AutoCrono.Enabled := FALSE;
       Tappa.Font.Color := clGrayText;
       CronoPortName := '';
       CronoPortNameI := -1;
	end;
   CronoModified := TRUE;
end;

procedure TConfForm.RGPortaChange(Sender: TObject);

begin
     s := RGPorta.Text;
  	  PortNameI := Ord(s[4])-ord('0');
	  ComModified := TRUE;
end;

procedure TConfForm.COMListChange(Sender: TObject);

var err: integer;

begin
	Val(Copy(Comlist.Text,4,1),CronoPortNameI,err);
	CronoModified := TRUE;
end;

procedure TConfForm.TappaChange(Sender: TObject);
begin
	NumTappa := Tappa.Value;
end;

procedure TConfForm.AutoCronoClick(Sender: TObject);
begin
	SendCrono := AutoCrono.Checked;
   CronoModified := TRUE;
end;

end.
