unit Edfoglio;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, Buttons, Config;

type
  TEditFoglio = class(TForm)
    EdTempi: TStringGrid;
    EdNote: TStringGrid;
    BitBtn2: TBitBtn;
    OKBtn: TBitBtn;
    PSFoglio: TStringGrid;
    procedure BitBtn2Click(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  EditFoglio: TEditFoglio;
  NuovoFoglio: Boolean;

implementation

uses Fogli;

{$R *.DFM}

procedure TEditFoglio.BitBtn2Click(Sender: TObject);
begin
	EditFoglio.Hide;
end;

procedure TEditFoglio.OKBtnClick(Sender: TObject);

var n,code,NumRecord: integer;
    pn,fn,m,s,c: integer;
    Err: boolean;

begin
	Err := False;
	Val(PSFoglio.Cells[0,1], Foglio.PSNum, code);
   if code <> 0 then begin
       PSFoglio.Cells[0,1] := '';
       Err := TRUE;
   end;
   Val(PsFoglio.Cells[1,1], Foglio.FoglioNum, code);
   if code <> 0 then begin
       PSFoglio.Cells[1,1] := '';
       Err := TRUE;
   end;
	Val(PsFoglio.Cells[2,1], Foglio.NumTempi, code);
   if code <> 0 then begin
       PSFoglio.Cells[2,1] := '';
       Err := TRUE;
   end;
   if not Err then	begin
   	Err := False;
		for n := 1 to Foglio.Numtempi do begin
			Val(EdTempi.Cells[0,n], Foglio.Tempi[n].Numero, code);
			if code <> 0 then begin
           	EdTempi.Cells[0,n] := '';
       		Err := TRUE;
			end;
			Val(Edtempi.Cells[1,n], Foglio.Tempi[n].Tempo.Minuti, code);
			if code <> 0 then begin
           	Edtempi.Cells[1,n] := '';
       		Err := TRUE;
			end;
			Val(EdTempi.Cells[2,n], Foglio.Tempi[n].Tempo.Secondi, code);
			if code <> 0 then begin
           	EdTempi.Cells[2,n] := '';
       		Err := TRUE;
			end;
			Val(EdTempi.Cells[3,n], Foglio.Tempi[n].Tempo.Centesimi, code);
			if code <> 0 then begin
           	EdTempi.Cells[3,n] := '';
       		Err := TRUE;
			end;
           Foglio.Tempi[n].Note := EdTempi.Cells[4,n];
		end;
   end;
   Foglio.Note[1] := EdNote.Cells[0,0];
   Foglio.Note[2] := EdNote.Cells[0,1];
   if Err then begin
		MessageBeep(MB_ICONQUESTION);
	end else begin
		if NuovoFoglio then NumRecord := FileSize(Quaderno)
       	else NumRecord := FFogli.ElencoFogli.ItemIndex;
		if NumRecord >= 0 then begin
			Seek(Quaderno, NumRecord);
			Write(Quaderno,Foglio);
       end;
  		EditFoglio.Hide;
	end;
   FFogli.AggiornaLista;
end;

procedure TEditFoglio.FormCreate(Sender: TObject);
begin
	PSFoglio.Cells[0,0] := 'P.S. Numero';
	PSFoglio.Cells[1,0] := 'Foglio Numero';
	PSFoglio.Cells[2,0] := 'Numero Tempi';
	EdTempi.Cells[0,0] := 'N';
	EdTempi.Cells[1,0] := 'Min';
	EdTempi.Cells[2,0] := 'Sec';
   EdTempi.Cells[3,0] := 'D/C';
	EdTempi.Cells[4,0] := 'Note';
end;

end.
